# coding: utf-8

"""
    Edge Impulse API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr
from edgeimpulse_api.models.data_campaign import DataCampaign
from edgeimpulse_api.models.data_campaign_graph import DataCampaignGraph

class GetOrganizationDataCampaignResponse(BaseModel):
    success: StrictBool = Field(..., description="Whether the operation succeeded")
    error: Optional[StrictStr] = Field(None, description="Optional error description (set if 'success' was false)")
    campaign: DataCampaign = ...
    graphs: List[DataCampaignGraph] = ...
    __properties = ["success", "error", "campaign", "graphs"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = False

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GetOrganizationDataCampaignResponse:
        """Create an instance of GetOrganizationDataCampaignResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of campaign
        if self.campaign:
            _dict['campaign'] = self.campaign.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in graphs (list)
        _items = []
        if self.graphs:
            for _item in self.graphs:
                if _item:
                    _items.append(_item.to_dict())
            _dict['graphs'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GetOrganizationDataCampaignResponse:
        """Create an instance of GetOrganizationDataCampaignResponse from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return GetOrganizationDataCampaignResponse.construct(**obj)

        _obj = GetOrganizationDataCampaignResponse.construct(**{
            "success": obj.get("success"),
            "error": obj.get("error"),
            "campaign": DataCampaign.from_dict(obj.get("campaign")) if obj.get("campaign") is not None else None,
            "graphs": [DataCampaignGraph.from_dict(_item) for _item in obj.get("graphs")] if obj.get("graphs") is not None else None
        })
        return _obj

