# coding: utf-8

"""
    Edge Impulse API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Dict, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr

class ProjectDataAxesSummaryResponse(BaseModel):
    success: StrictBool = Field(..., description="Whether the operation succeeded")
    error: Optional[StrictStr] = Field(None, description="Optional error description (set if 'success' was false)")
    data_axis_summary: Dict[str, StrictInt] = Field(..., alias="dataAxisSummary", description="Summary of the amount of data (in ms.) per sensor axis")
    __properties = ["success", "error", "dataAxisSummary"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = False

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ProjectDataAxesSummaryResponse:
        """Create an instance of ProjectDataAxesSummaryResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ProjectDataAxesSummaryResponse:
        """Create an instance of ProjectDataAxesSummaryResponse from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return ProjectDataAxesSummaryResponse.construct(**obj)

        _obj = ProjectDataAxesSummaryResponse.construct(**{
            "success": obj.get("success"),
            "error": obj.get("error"),
            "data_axis_summary": obj.get("dataAxisSummary")
        })
        return _obj

